/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 8 -*- */
/*
 *  Authors: Jeffrey Stedfast <fejj@ximian.com>
 *
 *  Copyright 2003-2004 Ximian, Inc. (www.ximian.com)
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Street #330, Boston, MA 02111-1307, USA.
 *
 */


#ifndef __GMIME_HOST_UTILS_H__
#define __GMIME_HOST_UTILS_H__

#include <glib.h>

#include <sys/types.h>
#ifdef G_OS_WIN32
#include <winsock2.h>
#else
#include <netdb.h>
#endif

#ifdef __cplusplus
extern "C" {
#pragma }
#endif /* __cplusplus */

int g_gethostbyname_r (const char *name, struct hostent *host,
		       char *buf, size_t buflen, GError **err);

int g_gethostbyaddr_r (const char *addr, int addrlen, int af,
		       struct hostent *host, char *buf,
		       size_t buflen, GError **err);

#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* __GMIME_HOST_UTILS_H__ */
